module.exports = {
    storageAPI:{
      data:"/storage-api/data",
      metadata:"/storage-api/data/metadata",
      header:"/storage-api/data/header",
    },
    contracts: {
        registryContractABI: [{"constant":true,"inputs":[{"name":"issuer","type":"address"},{"name":"subject","type":"address"},{"name":"key","type":"bytes32"}],"name":"getSigner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"subject","type":"address"},{"name":"key","type":"bytes32"},{"name":"value","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"setClaimWithSigner","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"issuer","type":"address"},{"name":"subject","type":"address"},{"name":"key","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"removeClaimWithSigner","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"},{"name":"","type":"address"},{"name":"","type":"bytes32"}],"name":"registrySigner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"subject","type":"address"},{"name":"key","type":"bytes32"},{"name":"value","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"setClaim","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"key","type":"bytes32"},{"name":"value","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"setSelfClaim","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"issuer","type":"address"},{"name":"subject","type":"address"},{"name":"key","type":"bytes32"}],"name":"verifyClaim","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"issuer","type":"address"},{"name":"subject","type":"address"},{"name":"key","type":"bytes32"}],"name":"removeClaim","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"issuer","type":"address"},{"name":"subject","type":"address"},{"name":"key","type":"bytes32"}],"name":"getClaim","outputs":[{"name":"","type":"bytes32"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"msgHash","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"recoverAddr","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"pure","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"},{"name":"","type":"address"},{"name":"","type":"bytes32"}],"name":"registry","outputs":[{"name":"","type":"bytes32"}],"payable":false,"stateMutability":"view","type":"function"},{"anonymous":false,"inputs":[{"indexed":true,"name":"issuer","type":"address"},{"indexed":true,"name":"subject","type":"address"},{"indexed":true,"name":"key","type":"bytes32"},{"indexed":false,"name":"value","type":"bytes32"},{"indexed":false,"name":"updatedAt","type":"uint256"}],"name":"ClaimSet","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"issuer","type":"address"},{"indexed":true,"name":"subject","type":"address"},{"indexed":true,"name":"key","type":"bytes32"},{"indexed":false,"name":"removedAt","type":"uint256"}],"name":"ClaimRemoved","type":"event"}],
        registryContractAddress: "0xcfc725B190E767a39De5AEf69A42f2924e34CC58",
        identityManagerAddress: "0x040191f1709366b85F9F0Ef7c55894Fe4FDB89B9",
        identityManagerABI: [{ "constant": false, "inputs": [{ "name": "identity", "type": "address" }, { "name": "destination", "type": "address" }, { "name": "value", "type": "uint256" }, { "name": "data", "type": "bytes" }], "name": "forward", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "identity", "type": "address" }, { "name": "recoveryKey", "type": "address" }], "name": "isRecovery", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "sender", "type": "address" }, { "name": "identity", "type": "address" }, { "name": "owner", "type": "address" }], "name": "removeOwner", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "sender", "type": "address" }, { "name": "identity", "type": "address" }, { "name": "recoveryKey", "type": "address" }], "name": "changeRecovery", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "identity", "type": "address" }, { "name": "owner", "type": "address" }], "name": "isOlderOwner", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "owner", "type": "address" }, { "name": "recoveryKey", "type": "address" }, { "name": "destination", "type": "address" }, { "name": "data", "type": "bytes" }], "name": "createIdentityWithCall", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "sender", "type": "address" }, { "name": "identity", "type": "address" }, { "name": "destination", "type": "address" }, { "name": "value", "type": "uint256" }, { "name": "data", "type": "bytes" }], "name": "forwardTo", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "sender", "type": "address" }, { "name": "identity", "type": "address" }, { "name": "newOwner", "type": "address" }], "name": "addOwnerFromRecovery", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "owner", "type": "address" }, { "name": "recoveryKey", "type": "address" }], "name": "registerIdentity", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "identity", "type": "address" }, { "name": "owner", "type": "address" }], "name": "isOwner", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "sender", "type": "address" }, { "name": "identity", "type": "address" }, { "name": "newOwner", "type": "address" }], "name": "addOwner", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "owner", "type": "address" }, { "name": "recoveryKey", "type": "address" }], "name": "createIdentity", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "inputs": [{ "name": "_userTimeLock", "type": "uint256" }, { "name": "_adminTimeLock", "type": "uint256" }, { "name": "_adminRate", "type": "uint256" }, { "name": "_relayAddress", "type": "address" }], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "identity", "type": "address" }, { "indexed": true, "name": "creator", "type": "address" }, { "indexed": false, "name": "owner", "type": "address" }, { "indexed": true, "name": "recoveryKey", "type": "address" }], "name": "LogIdentityCreated", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "identity", "type": "address" }, { "indexed": true, "name": "owner", "type": "address" }, { "indexed": false, "name": "instigator", "type": "address" }], "name": "LogOwnerAdded", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "identity", "type": "address" }, { "indexed": true, "name": "owner", "type": "address" }, { "indexed": false, "name": "instigator", "type": "address" }], "name": "LogOwnerRemoved", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "identity", "type": "address" }, { "indexed": true, "name": "recoveryKey", "type": "address" }, { "indexed": false, "name": "instigator", "type": "address" }], "name": "LogRecoveryChanged", "type": "event" }],
        storageAddress: "0xeEC3BB5CDE7dC9928b9aCdEC0d96dF56297dE9C9",
        storageABI: [{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"}],"name":"removeDataItem","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"}],"name":"getAccessKeysForData","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"wallet","type":"address"}],"name":"addAccess","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"storageKeys","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"wallet","type":"address"}],"name":"getIdsForAccount","outputs":[{"name":"","type":"bytes32[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"wallet","type":"address"},{"name":"key","type":"bytes32"}],"name":"getIdsForAccountByKey","outputs":[{"name":"","type":"bytes32[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"signedMessage","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"canKeyUpdateData","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"signedMessage","type":"bytes32"},{"name":"v","type":"uint8"},{"name":"r","type":"bytes32"},{"name":"s","type":"bytes32"}],"name":"canKeyAccessData","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"storageRegisterDepositAmount","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"storageData","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"sender","type":"address"},{"name":"amount","type":"uint256"}],"name":"withdrawal","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"getStorageItemCount","outputs":[{"name":"entityCount","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"wallet","type":"address"}],"name":"removeAccess","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"}],"name":"getNodesForItem","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_registratorAddress","type":"address"}],"name":"setRegistrator","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"keyname","type":"bytes32"}],"name":"removeKey","outputs":[{"name":"success","type":"bool"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"key","type":"bytes32"}],"name":"getIdsForKey","outputs":[{"name":"","type":"bytes32[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"owner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"newOwner","type":"address"}],"name":"transferOwner","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"}],"name":"isItemDeleted","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"owner","type":"address"},{"name":"dataHash","type":"bytes32"},{"name":"merkleRoot","type":"bytes32"},{"name":"key","type":"bytes32"},{"name":"size","type":"uint256"},{"name":"replicationMode","type":"uint256"},{"name":"trusted","type":"address[]"}],"name":"setStorage","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":false,"inputs":[{"name":"_vaultManagerAddress","type":"address"}],"name":"setVaultManager","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"accessor","type":"address"}],"name":"canKeyAccessData","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"dataHash","type":"bytes32"}],"name":"getItemForId","outputs":[{"name":"owner","type":"address"},{"name":"merkle","type":"bytes32"},{"name":"size","type":"uint256"},{"name":"keyname","type":"bytes32"},{"name":"replicationMode","type":"uint256"},{"name":"createdAt","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"wallet","type":"address"},{"name":"key","type":"bytes32"}],"name":"getActualIdForKey","outputs":[{"name":"","type":"bytes32"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"owner","type":"address"},{"name":"dataHash","type":"bytes32"}],"name":"hasItemDeleted","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"amount","type":"uint256"}],"name":"setStorageDepositAmount","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"registrator","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_storageData","type":"address"}],"name":"setStorageDataContract","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"_foreverStorage","type":"address"}],"name":"setStorageContract","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"storageNode","type":"address"}],"name":"forceStorageProof","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"wallet","type":"address"}],"name":"getDepositBalance","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"newOwner","type":"address"}],"name":"transferOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"sender","type":"address"}],"name":"deposit","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"vault","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"foreverStorage","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"inputs":[{"name":"_vault","type":"address"},{"name":"_registrator","type":"address"},{"name":"_forever","type":"address"},{"name":"_storageKeys","type":"address"},{"name":"_storageData","type":"address"}],"payable":false,"stateMutability":"nonpayable","type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"sender","type":"address"},{"indexed":true,"name":"owner","type":"address"},{"indexed":false,"name":"id","type":"bytes32"}],"name":"StorageItemAdded","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"dataHash","type":"bytes32"}],"name":"StorageItemRemoved","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"owner","type":"address"},{"indexed":true,"name":"dataHash","type":"bytes32"},{"indexed":true,"name":"publicKey","type":"address"}],"name":"StorageItemPublicKeyAdded","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"owner","type":"address"},{"indexed":true,"name":"dataHash","type":"bytes32"},{"indexed":true,"name":"publicKey","type":"address"}],"name":"StorageItemPublicKeyRemoved","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"sender","type":"address"},{"indexed":false,"name":"owner","type":"address"},{"indexed":false,"name":"amount","type":"uint256"}],"name":"Deposit","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"owner","type":"address"},{"indexed":false,"name":"amount","type":"uint256"}],"name":"Withdrawal","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"storageNode","type":"address"},{"indexed":true,"name":"dataHash","type":"bytes32"},{"indexed":false,"name":"chunkIndex","type":"uint256"}],"name":"StorageProofNeeded","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"dataHash","type":"bytes32"},{"indexed":false,"name":"addresses","type":"address"}],"name":"StorageNodesSelected","type":"event"}],
        storageDataAddress: "0x448Cc8f0c0C6D439c344CdAD5F93110BE9F0a169",
        storageDataABI: [ { "constant": false, "inputs": [ { "name": "admin", "type": "address" } ], "name": "removeAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "a", "type": "address[]" }, { "name": "dataHash", "type": "bytes32" }, { "name": "size", "type": "uint256" } ], "name": "setNode", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "dataHash", "type": "bytes32" }, { "name": "wallet", "type": "address" } ], "name": "addAccess", "outputs": [ { "name": "", "type": "bool" } ], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [ { "name": "", "type": "address" } ], "name": "admins", "outputs": [ { "name": "", "type": "bool", "value": true } ], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [ { "name": "dataHash", "type": "bytes32" }, { "name": "wallet", "type": "address" } ], "name": "removeAccess", "outputs": [ { "name": "", "type": "bool" } ], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "owner", "type": "address" }, { "name": "dataHash", "type": "bytes32" } ], "name": "remove", "outputs": [ { "name": "", "type": "bool" } ], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "admin", "type": "address" } ], "name": "addAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "owner", "outputs": [ { "name": "", "type": "address", "value": "0xbddb8404281d830de5e200eb241aec3c97d885bc" } ], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [ { "name": "dataHash", "type": "bytes32" }, { "name": "sender", "type": "address" }, { "name": "owner", "type": "address" }, { "name": "merkleRoot", "type": "bytes32" }, { "name": "size", "type": "uint256" }, { "name": "key", "type": "string" }, { "name": "replicationMode", "type": "uint256" }, { "name": "trusted", "type": "address[]" } ], "name": "set", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "_foreverStorage", "type": "address" } ], "name": "setStorageContract", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [ { "name": "newOwner", "type": "address" } ], "name": "transferOwnership", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "foreverStorage", "outputs": [ { "name": "", "type": "address", "value": "0x88f24021ca59cd74b12bfc5816d99b38e47e20c7" } ], "payable": false, "stateMutability": "view", "type": "function" }, { "inputs": [ { "name": "_forever", "type": "address" }, { "name": "_storageKeys", "type": "address" } ], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "anonymous": false, "inputs": [ { "indexed": true, "name": "admin", "type": "address" } ], "name": "AddAdmin", "type": "event" }, { "anonymous": false, "inputs": [ { "indexed": true, "name": "admin", "type": "address" } ], "name": "RemoveAdmin", "type": "event" } ],
        storageCostsAddress: "0x151929dcf4688fb77c2c0731ee6783e134e470f8",
        storageCostsABI: [{ "constant": true, "inputs": [], "name": "checkStatus", "outputs": [], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [], "name": "unpause", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "operator", "type": "address" }], "name": "setRateOperator", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "pausableAdmin", "type": "address" }], "name": "addPausableAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "getStatus", "outputs": [{ "name": "", "type": "string" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "paused", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "value", "type": "uint256" }], "name": "setCoinDollarRate", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [], "name": "pause", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "owner", "outputs": [{ "name": "", "type": "address" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "getDollarRate", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "size", "type": "uint256" }, { "name": "downloads", "type": "uint256" }], "name": "getTrafficCosts", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "estimatedGB", "type": "uint256" }], "name": "getTrafficCostsGB", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "value", "type": "uint256" }], "name": "setCostsPerGBDataDownloaded", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "pausableAdmin", "type": "address" }], "name": "removePausableAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "newOwner", "type": "address" }], "name": "transferOwnership", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "size", "type": "uint256" }, { "name": "duration", "type": "uint256" }], "name": "getStorageCosts", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "value", "type": "uint256" }], "name": "setCostsPerGBDataStored", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "inputs": [], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "anonymous": false, "inputs": [{ "indexed": false, "name": "sender", "type": "address" }, { "indexed": false, "name": "oldValue", "type": "uint256" }, { "indexed": false, "name": "newValue", "type": "uint256" }], "name": "CoinValueChanged", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": false, "name": "sender", "type": "address" }, { "indexed": false, "name": "oldValue", "type": "uint256" }, { "indexed": false, "name": "newValue", "type": "uint256" }], "name": "CostsPerGBValueChanged", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": false, "name": "sender", "type": "address" }, { "indexed": false, "name": "oldValue", "type": "uint256" }, { "indexed": false, "name": "newValue", "type": "uint256" }], "name": "CostsPerGBDownloadedValueChanged", "type": "event" }, { "anonymous": false, "inputs": [], "name": "Unpause", "type": "event" }, { "anonymous": false, "inputs": [], "name": "Pause", "type": "event" }],
        vaultContractABI: [{ "constant": false, "inputs": [{ "name": "_address", "type": "address" }, { "name": "_id", "type": "bytes32" }, { "name": "_value", "type": "uint256" }], "name": "subtractStorageBalance", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "admin", "type": "address" }], "name": "removeAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "_address", "type": "address" }, { "name": "_value", "type": "uint256" }], "name": "addBalance", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "", "type": "bytes32" }, { "name": "", "type": "address" }], "name": "storageVault", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "", "type": "address" }], "name": "admins", "outputs": [{ "name": "", "type": "bool" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "_address", "type": "address" }, { "name": "_id", "type": "bytes32" }], "name": "getStorageBalance", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "admin", "type": "address" }], "name": "addAdmin", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "owner", "outputs": [{ "name": "", "type": "address" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "", "type": "address" }], "name": "lockedAmounts", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "_address", "type": "address" }, { "name": "_value", "type": "uint256" }], "name": "subtractBalance", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "_address", "type": "address" }, { "name": "_id", "type": "bytes32" }, { "name": "_value", "type": "uint256" }], "name": "addStorageBalance", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "newOwner", "type": "address" }], "name": "transferOwnership", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "_address", "type": "address" }], "name": "getBalance", "outputs": [{ "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "inputs": [], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "admin", "type": "address" }], "name": "AddAdmin", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "admin", "type": "address" }], "name": "RemoveAdmin", "type": "event" }],
        vaultContractAddress: "0xe20a391beace108a30fa2600e59ea7b2eb50b4b6",
        datumPlasmaPOAAddress: "0xE2b809D47C91dB45906dA739fdAE868e556Dd56F",
        datumPlasmaPOAABI: [{ "constant": false, "inputs": [{ "name": "_to", "type": "address" }, { "name": "_value", "type": "uint256" }, { "name": "txHash", "type": "bytes32" }], "name": "deposit", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "newOperator", "type": "address" }], "name": "transferOperator", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "name": "", "type": "address" }, { "name": "", "type": "bytes32" }], "name": "depositsProcessed", "outputs": [{ "name": "", "type": "uint256", "value": "0" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "operator", "outputs": [{ "name": "", "type": "address", "value": "0xcc7dba22213186071945a0d2d88466a3deb04df3" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "migrator", "outputs": [{ "name": "", "type": "address", "value": "0x3d40f2f9605a8259fdcfd6106467bb5896bfe5f1" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "name": "", "type": "address" }], "name": "migrationProcessed", "outputs": [{ "name": "", "type": "bool", "value": false }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "migratorAviableAmount", "outputs": [{ "name": "", "type": "uint256", "value": "1.1109867e+25" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "name": "_to", "type": "address" }], "name": "withdrawal", "outputs": [], "payable": true, "stateMutability": "payable", "type": "function" }, { "constant": false, "inputs": [{ "name": "_to", "type": "address" }, { "name": "_value", "type": "uint256" }], "name": "migrateFunds", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "name": "_migrator", "type": "address" }, { "name": "_maxAmount", "type": "uint256" }], "name": "setMigrationAddress", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "inputs": [], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "payable": true, "stateMutability": "payable", "type": "fallback" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "from", "type": "address" }, { "indexed": false, "name": "value", "type": "uint256" }], "name": "Deposit", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "from", "type": "address" }, { "indexed": true, "name": "to", "type": "address" }, { "indexed": false, "name": "value", "type": "uint256" }], "name": "WithdrawalRequest", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "from", "type": "address" }, { "indexed": false, "name": "value", "type": "uint256" }], "name": "LogFundingReceived", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "name": "sender", "type": "address" }, { "indexed": false, "name": "maxValue", "type": "uint256" }], "name": "MigratorSet", "type": "event" }],
        nodeRegistratorAddress: "0x8b588dc9cd4ec9b2fdb89f0025393cc9fb482461",
        nodeRegistratorABI: [{"constant":false,"inputs":[{"name":"bOnline","type":"bool"}],"name":"setNodeMode","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"admin","type":"address"}],"name":"removeAdmin","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"seed","type":"uint256"}],"name":"getRandomDatumNode","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[],"name":"getFailedStorageProofs","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"storageKeys","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"getNodeCount","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[],"name":"unregisterNode","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"amount","type":"uint256"}],"name":"setRegisterNodeDepositAmount","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"","type":"address"}],"name":"admins","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"nodeRegisterMaxDepositAmount","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"count","type":"uint256"}],"name":"getRandomNodes","outputs":[{"name":"","type":"address[]"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[{"name":"node","type":"address"}],"name":"nodeExists","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"amount","type":"uint256"}],"name":"setMaxStorageNodes","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"node","type":"address"}],"name":"getNodeInfo","outputs":[{"name":"endpoint","type":"string"},{"name":"bandwidth","type":"uint256"},{"name":"region","type":"uint256"},{"name":"status","type":"string"},{"name":"online","type":"bool"},{"name":"datumNode","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"bCollect","type":"bool"}],"name":"collectRewards","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"getStakingBalance","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"admin","type":"address"}],"name":"addAdmin","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"registrationOpen","outputs":[{"name":"","type":"bool"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_nodeData","type":"address"}],"name":"setNodeData","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"alpha","type":"uint256[]"},{"name":"beta","type":"uint256[2][2]"},{"name":"gamma","type":"uint256[2][2]"},{"name":"delta","type":"uint256[2][2]"},{"name":"gammaABC","type":"uint256[2][3]"},{"name":"proofA","type":"uint256[]"},{"name":"proofB","type":"uint256[2][2]"},{"name":"proofC","type":"uint256[]"},{"name":"input","type":"uint256[]"},{"name":"dataHash","type":"bytes32"}],"name":"VerifyZKProof","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"dataHash","type":"bytes32"},{"name":"proof","type":"bytes32[]"},{"name":"leafHash","type":"bytes32"}],"name":"giveForcedStorageProof","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"_nodeAddress","type":"address"}],"name":"removeNodeFromAdmin","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"endpoint","type":"string"},{"name":"bandwidth","type":"uint256"},{"name":"region","type":"uint256"}],"name":"registerNode","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"owner","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_foreverStorageAddress","type":"address"}],"name":"setStorage","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[],"name":"estimateRewards","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[],"name":"unregisterNodeStart","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"_vaultManagerAddress","type":"address"}],"name":"setVaultManager","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[{"name":"seed","type":"uint256"}],"name":"getRandomNode","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"maxStorageNodes","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[],"name":"deposit","outputs":[],"payable":true,"stateMutability":"payable","type":"function"},{"constant":true,"inputs":[],"name":"nodeData","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":false,"inputs":[{"name":"_state","type":"bool"}],"name":"setRegistrationState","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":false,"inputs":[{"name":"newOwner","type":"address"}],"name":"transferOwnership","outputs":[],"payable":false,"stateMutability":"nonpayable","type":"function"},{"constant":true,"inputs":[],"name":"vault","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"nodeRegisterDepositAmount","outputs":[{"name":"","type":"uint256"}],"payable":false,"stateMutability":"view","type":"function"},{"constant":true,"inputs":[],"name":"foreverStorage","outputs":[{"name":"","type":"address"}],"payable":false,"stateMutability":"view","type":"function"},{"inputs":[{"name":"_vault","type":"address"},{"name":"_forever","type":"address"},{"name":"_storageKeys","type":"address"},{"name":"_nodeData","type":"address"}],"payable":false,"stateMutability":"nonpayable","type":"constructor"},{"anonymous":false,"inputs":[{"indexed":true,"name":"storageNode","type":"address"},{"indexed":false,"name":"endpoint","type":"string"},{"indexed":false,"name":"bandwidth","type":"uint256"},{"indexed":false,"name":"region","type":"uint256"}],"name":"NodeRegistered","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"storageNode","type":"address"},{"indexed":false,"name":"endpoint","type":"string"},{"indexed":false,"name":"bandwidth","type":"uint256"},{"indexed":false,"name":"region","type":"uint256"}],"name":"NodeUpdated","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"storageNode","type":"address"}],"name":"NodeUnRegistered","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"storageNode","type":"address"},{"indexed":false,"name":"timestamp","type":"uint256"}],"name":"NodeStartUnRegister","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"storageNode","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"RewardCollected","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"owner","type":"address"},{"indexed":false,"name":"amount","type":"uint256"}],"name":"Deposit","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"verified","type":"bool"}],"name":"ZKProofVerified","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"storageNode","type":"address"},{"indexed":true,"name":"dataHash","type":"bytes32"}],"name":"StorageProofSuccessFull","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"storageNode","type":"address"},{"indexed":true,"name":"dataHash","type":"bytes32"},{"indexed":false,"name":"timestamp","type":"uint256"}],"name":"StorageProofFailed","type":"event"},{"anonymous":false,"inputs":[{"indexed":false,"name":"dataHash","type":"bytes32"},{"indexed":false,"name":"storageNode","type":"address"},{"indexed":false,"name":"value","type":"uint256"}],"name":"StorageNodeRewarded","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"admin","type":"address"}],"name":"AddAdmin","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"name":"admin","type":"address"}],"name":"RemoveAdmin","type":"event"}]
    },
    network: {
        network_id: "51515",
        network_name: "0xc93b"
    }
};
